function sup00100_consolidacao_de_solicitacao_Controller(ScreenService, MessageService, General, localStorageEngine, Parametros, Sup03600PedidoColetaService) {

    var self = this;
    
    function concatArrayForParams(value, defaultValue = 'T') {
        if (!Util.isEmptyOrBlank(value)) {
            return Array.isArray(value) ? value.join('_') : value;
        }
    
        return defaultValue;
    }
    
    self.validaProduto = function(prodInicial, prodFinal) {
        
        if (General.comparaPratoProduto(prodInicial, prodFinal, getLocalVar('CDPICTPROD'))) {
            return true;
        }
        MessageService.showMessageByCode("cmp#PRODUTO_INICIAL_MENOR_IGUAL_FINAL");
        return false; 
    };
   
    this.ConsolidarSolicitacao = function(widget) {
        let row = widget.currentRow;
        
        if (widget.isValid()) {
            if (self.validaProduto(row.CDPRODINI, row.CDPRODFIN)) {
                
                prepareRow(row);
                
                General.callRestEngine('cmp_solicitacao_consolidacao#/validaFilial',"Row", row).then(function(res) {
                    ScreenService.showMessage(res.messages[0].message);
                });
            }
        }
    };
    
    function verifiyStringInArray(array, string) {
        if (Array.isArray(array) && array.indexOf(string) > -1) {
            return 'S';
        } else {
            return 'N';
        }
    }
    
    function prepareRow(row) {
        row.CONSISOL      = verifiyStringInArray(row.CONSIDERAR, "CONSISOL");
        row.CONSIAF       = verifiyStringInArray(row.CONSIDERAR, "CONSIAF");
        row.CDFILIALSOL   = verifyArrayIsValid(row.CDFILIALSOL);
        row.CDOPERADOR    = verifyArrayIsValid(row.CDOPERADOR);
        row.NRSOLICMP     = verifyArrayIsValid(row.NRSOLICMP);
        row.CHAVE         = verifyArrayIsValid(row.CHAVE);
        row.CDFILIAIS     = concatArrayForParams(row.CDFILIALSOL, null);
        row.CDFILIALPRINC = row.CDFILIALPRINC ? row.CDFILIALPRINC : '';
        row.CDFILIALEST   = row.CDFILIALEST   ? row.CDFILIALEST   : '';
        row.DATAINI       = row.INTERVAL_DT.start;
        row.DATAFIN       = row.INTERVAL_DT.end;
        row.DTPROCESS     = moment(getLocalVar('DTPROCESSA'), 'DD/MM/YYYY').format('DD/MM/YYYY');
        row.CDFILIAL      = getLocalVar('CDFILIAL');
    }
    
    function verifyArrayIsValid(array, defaultReturn = null) {
        if (!Util.isEmptyOrBlank(array)) {
            return Array.isArray(array) ? array : defaultReturn;
        }
    
        return defaultReturn;
    }
    
    self.concatenaFilial = function(arrayFilial){
        var filiais = arrayFilial.join('_');
        return filiais;
    };
    
    this.setEstoque = function(field){
        var widget =  field.widget;
        if(widget.currentRow.CONSIDERAEST == "S"){
            widget.getField('NMFILIALEST').readOnly = false;
            widget.getField('NMFILIALEST').validations = {"required": true};
        }else{
            widget.getField('NMFILIALEST').readOnly = true;
            widget.getField('NMFILIALEST').validations = {};
        }  
    };
    
    this.controlaFields = function(widget){
        widget.currentRow.CDFILIALPRINC = getLocalVar('CDFILIAL');
        widget.currentRow.CDFILIALEST = getLocalVar('CDFILIAL');
        widget.getField('INTERVAL_DT').defaultValue = {
            "start": moment(new Date()).format("DD/MM/YYYY"),
            "end": moment(new Date()).format("DD/MM/YYYY") 
        };
        widget.applyDefaultValue();
        if(widget.currentRow.NMFILIALPRINC && widget.currentRow.INTERVAL_DT){
            widget.getField('SOLICITACAO').readOnly = false;
        }else{
            widget.getField('SOLICITACAO').readOnly = true;
        }
    };
    
    this.setDataFilterSolicitacao = function(field){
        var dataIni = field.widget.currentRow.INTERVAL_DT ? field.widget.currentRow.INTERVAL_DT.start : null;
        var dataFin = field.widget.currentRow.INTERVAL_DT ? field.widget.currentRow.INTERVAL_DT.end : null;
        field.dataSourceFilter = [
            {
                "name": "P_DATAINI",
                "operator": "=",
                "value": dataIni  
            },
            {
                "name": "P_DATAFIN",
                "operator": "=",
                "value": dataFin  
            },
            {
                "name": "P_CDFILIAL",
                "operator": "=",
                "value": this.concatArrayForParams(field.widget.currentRow.CDFILIALSOL)
            },   
            {
                "name": "P_NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')  
            }    
        ];
        field.reload().then(function(success){
            if(field.dataSource.data.length <= 0){
                MessageService.showMessageByCode("cmp#NAO_HA_DADOS_PER_UNI");
            }
        });
    };
    
    this.controlaFieldSolicitacao = function(widget){
        if(widget.currentRow.NMFILIALPRINC && widget.currentRow.INTERVAL_DT.start && widget.currentRow.INTERVAL_DT.end){
            widget.getField('SOLICITACAO').readOnly = false;
        }else{
            widget.getField('SOLICITACAO').readOnly = true;
        }
    };
    
    
    this.concatArrayForParams = function (arr, defaultValue) {
        return !Util.isEmptyOrBlank(arr) ? arr.join('_') : defaultValue || 'T';
    };

}

Configuration(function(ContextRegister) {
    ContextRegister.register('sup00100_consolidacao_de_solicitacao_Controller', sup00100_consolidacao_de_solicitacao_Controller);
});