function Cmp05700JustificativaSolicitacaoController(ScreenService, templateManager, General, ZhFilterPreferences, Utilities) {
    
    this.setFilterInitValues = function(widget) {
        const filterRow = {
            "INTERVALDT": {
                "start": moment().format('L'),
                "end": moment().format('L')
            },
            "NRORG": getLocalVar('NRORG')
        };
        
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
    };
    
    this.widgetOnEnterOnce = function(widget) {
        widget.getField("CDFILSOLEXT").filterProperties.readOnly = (window.projectCorp) ?  false : true;
        
        const filterRow = {
    	    INTERVALDT : {
    	        'formattedStart': moment().format('DD/MM/YYYY'),
    	        'formattedEnd': moment().format('DD/MM/YYYY'),
    	        'start': moment().format('DD/MM/YYYY'),
    	        'end': moment().format('DD/MM/YYYY')
    	    }     
        };
        
        //widget.getField("CDFILSOLEXT").reload();
        Utilities.startFilter(widget, filterRow);
        //this.setFilterInitValues(widget);
    };

    this.filtrar = function(args) {
        var filterRow = args.e.preference.FILTER_ROW;
        
        if(typeof(filterRow) === 'object'){
            args.e.preference.CUSTOM_FILTER_ROW = {
                "P_DTOPERINI": filterRow.INTERVALDT.start,
                "P_DTOPERFIN": filterRow.INTERVALDT.end,
                "P_CDFILSOLEXT": Array.isArray(filterRow.CDFILSOLEXT) && filterRow.CDFILSOLEXT.length ? filterRow.CDFILSOLEXT.join('_') : 'T',
                "NRORG": filterRow.NRORG
            };
        }
        
        /* Impede que, ao pesquisar por TODAS as Unidades (campo em branco), 
        o campo 'Unidade Solicitante' do corpo do relatório venha somente com a
        Unidade logada preenchida.
        */
        if (args.e.preference.CUSTOM_FILTER_ROW.P_CDFILSOLEXT === 'T') {
            args.owner.getField('CDFILSOLEXT').dataSource.reload();
        }
    };
    
    this.setStripe = function(widget) {
        var filterRow = widget.appliedFilter.FILTER_ROW;
        
        widget.container.getWidget("stripe").currentRow.DTOPERINI = filterRow.INTERVALDT.start + " a " + filterRow.INTERVALDT.end;
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Cmp05700JustificativaSolicitacaoController', Cmp05700JustificativaSolicitacaoController);
});